
import java.util.Random;

public class BubbleSort {

    static class ListNode {

        int val;
        ListNode next;
    }

    static void swapVal(ListNode l1, ListNode l2) {
        int tmp = l1.val;
        l1.val = l2.val;
        l2.val = tmp;
    }

    public static void main(String[] args) {
        int N = 20;

        ListNode lista = null;

        Random rGen = new Random();

        for (int i = 0; i < N; i++) {
            ListNode next = lista;

            lista = new ListNode();

            lista.val = rGen.nextInt(100);
            lista.next = next;
        }


        System.out.println("Przed:");

        ListNode pos = lista;

        while (pos != null) {
            System.out.format("%d ", pos.val);
            pos = pos.next;
        }
        System.out.println();



        int done = 0;

        while (done == 0) {
            done = 1;
            pos = lista;
            while (pos.next != null) {

                if (pos.next.val < pos.val) {
                    swapVal(pos, pos.next);
                    done = 0;
                }

                pos = pos.next;
            }
        }


        System.out.println("Po:");
        pos = lista;
        while (pos != null) {
            System.out.format("%d ", pos.val);
            pos = pos.next;
        }
        System.out.println();
    }
}
